#ifndef section_five
#define section_five

#include "gwindow.h"

struct ListNode {
    int data;
    ListNode* next;

    ListNode(int data, ListNode* next) {
        this->data = data;
        this->next = next;
    }
};

struct PointNode {
    GPoint data;
    PointNode* next;

    PointNode(GPoint data, PointNode* next = nullptr) {
        this->data = data;
        this->next = next;
    }
};

/* Function to conveniently construct a linked list from a data vector;
 * used below in main() */
ListNode* buildLinkedList(const Vector<int>& list) {
    if(list.isEmpty()) {
        return nullptr;
    }
    ListNode* front = new ListNode(list[0], nullptr);
    ListNode* current = front;
    for (int i = 1; i < list.size(); i++) {
        current->next = new ListNode(list[i], nullptr);
        current = current->next;
    }
    return front;
}

std::string linkedListToString(const ListNode* front) {
    std::stringstream toReturn;
    toReturn << "{";
    if (front != nullptr) {
        toReturn << front->data;
        front = front->next;
        while (front != nullptr) {
            toReturn << ", " << front->data;
            front = front->next;
        }
    }
    toReturn << "}";
    return toReturn.str();
}

#endif
